local EventList
StaticPopupDialogs["ADDONMANAGE_SETOVERWRITE"] = {
	button1=YES,
	button2=NO,
	text="A set named |cffbbbbff%s|r already exists.\nDo you want to overwrite it?",
	showAlert=true,
	OnAccept=function(self,data,data2)
		local d = AddonManage_Sets[data.name]
		d.events = data.events or {}
		d.filter = data.filter
		data2.events:SetList(EventList)
		data2.namebox:SetText("")
		data2.filter:SetText("")
		data2.apply:SetDisabled(true)
		AddonManage.config.sets.select:SetList(AddonManage:GenerateSetList())
		AddonManage:ReRegisterEvents()
		AddonManage.config.sets.setedit:Hide()
	end,
	whileDead=true,
	hideOnEscape=true,
	timeout=0,
}
StaticPopupDialogs["ADDONMANAGE_SETTRIGGER"] = {
	button1=YES,
	button2=NO,
	text="AddonManage set |cffbbbbff%s|r has been triggered.\nDo you want to execute the following actions and reload your UI?\n%s",
	showAlert=true,
	OnAccept = function(self,data)
		for i,k in pairs(data) do
			if k then
				EnableAddOn(i)
			else
				DisableAddOn(i)
			end
		end
		ReloadUI()
	end,
	whileDead=true,
	hideOnEscape=false,
	timeout=0,
}
local function ClearEditBoxFocus(editbox)
	editbox:SetDisabled(true)
	editbox:SetDisabled(false)
end
AddonManage = LibStub("AceAddon-3.0"):NewAddon("AddonManage")
local AceGUI = LibStub("AceGUI-3.0")
local AddonManage = AddonManage
local function uncolorstring(s)
	s = string.gsub(s, "|cff%S%S%S%S%S%S", "")
	s = string.gsub(s, "|r", "")
	return s
end
local setcallframe = CreateFrame("Frame")
setcallframe:SetScript("OnEvent", function(self,event,...)
	for title, data in pairs(AddonManage_Sets) do
		if setfenv(loadstring(data.filter),setmetatable({event=event, args={...}},{__index=_G}))() then
			local d = StaticPopup_Show("ADDONMANAGE_SETTRIGGER", data.name, AddonManage:GenerateNotifyList(data.addons))
			d.data = data.addons
		end
	end
end)
function AddonManage:GenerateNotifyList(addons)
	local strings = {}
	for f,shouldLoad in pairs(addons) do
		local name = AddonManage.addons[AddonManage.nums[f]].t
		tinsert(strings, "|cff"..(shouldLoad and "00ff00Enable" or "ff0000Disable")..":  "..uncolorstring(name).."|r")
	end
	return table.concat(strings, "\n")
end
function AddonManage:ReRegisterEvents()
	--[===[@debug@
	print("Re-Registering all events!")
	--@end-debug@]===]
	setcallframe:UnregisterAllEvents()
	local events = {}
	for name, data in pairs(AddonManage_Sets) do
		for event in pairs(data.events) do
			events[event] = true
		end
	end
	for event in pairs(events) do
		--[===[@debug@
		print("Registering: "..event)
		--@end-debug@]===]
		setcallframe:RegisterEvent(event)
	end
end
function AddonManage:GenerateSetList()
	AddonManage_Sets = AddonManage_Sets or {}
	local t = {}
	for key in pairs(AddonManage_Sets) do
		t[key] = key
	end
	return t
end
function AddonManage:OnInitialize()
	--create game menu button
	local gmbtn = CreateFrame("Button", "GameMenuButtonAddOns", GameMenuFrame)
	gmbtn:RegisterForClicks("LeftButtonUp")
	gmbtn:SetScript("OnClick", function() GameMenuFrame:Hide() AddonManage.config:Show() if not AddonManage.IsLayouted then AddonManage.config:ResumeLayouts() end end)
	gmbtn:SetHeight(21)
	gmbtn:SetWidth(144)
	gmbtn:SetPoint("TOP", GameMenuButtonKeybindings, "BOTTOM", 0, -1)
	GameMenuButtonMacros:ClearAllPoints()
	GameMenuButtonMacros:SetPoint("TOP", gmbtn, "BOTTOM", 0, -1)
	gmbtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	gmbtn:SetHighlightTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	gmbtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	gmbtn:SetDisabledTexture("Interface\\Buttons\\UI-Panel-Button-Disabled")
	gmbtn:GetNormalTexture():SetTexCoord(0,0,0,0.6875,0.625,0,0.625,0.6875)
	gmbtn:GetHighlightTexture():SetTexCoord(0,0,0,0.6875,0.625,0,0.625,0.6875)
	gmbtn:GetPushedTexture():SetTexCoord(0,0,0,0.6875,0.625,0,0.625,0.6875)
	gmbtn:GetDisabledTexture():SetTexCoord(0,0,0,0.6875,0.625,0,0.625,0.6875)
	local fntstrng = gmbtn:CreateFontString("GameMenuButtonAddOnsText", "ARTWORK")
	fntstrng:SetFont("Fonts\\FRIZQT__.TTF", 12)
	fntstrng:SetTextColor(1,1,1,1)
	fntstrng:SetText("AddOns")
	gmbtn:SetFontString(fntstrng)
	--use getheight instead of absolute values for compability with other button-adding addons
	GameMenuFrame:SetHeight(GameMenuFrame:GetHeight()+22)
	--finished creating game menu button
	if (not AddonManage_Events) or ((select(4,GetBuildInfo())) > AddonManage_Events.uiversion) then
		AddonManage_Events={events={},uiversion=(select(4,GetBuildInfo()))}
	end
	local framecap = CreateFrame("Frame")
	framecap:SetScript("OnEvent", function(self,event)
		if not AddonManage_Events.events[event] then AddonManage_Events.events[event] = event end
	end)
	framecap:RegisterAllEvents()
	EventList = AddonManage_Events.events
	local at, ud, dp, nums, tt = {}, {}, {}, {}, {}
	for num_addon=1, GetNumAddOns() do
		local fold, title, notes, enabled, loadable, reason = GetAddOnInfo(num_addon)
		if not loadable and ((reason == "DEP_DISABLED") or (reason == "DISABLED")) then
			loadable = true
			reason = nil
		end
		local deps = {GetAddOnDependencies(num_addon)}
		for n, addon in ipairs(deps) do
			dp[addon] = dp[addon] or {}
			tinsert(dp[addon], fold)
		end
		tinsert(at, {f=fold, t=title, n=notes, e=enabled, l=loadable, r=reason, i=num_addon, d=deps})
		tt[fold] = title
		ud[title] = false
	end
	--table.sort(at, function(a,b) if a.e == b.e then return a.t:lower() < b.t:lower() else return a.e and true or false end end)
	table.sort(at, function(a,b) return a.t:lower() < b.t:lower() end)
	for num, data in ipairs(at) do
		nums[data.f] = num
	end
	self.addons = at
	self.update = ud
	self.rdeps = dp
	self.nums = nums
	self.titles = tt
	local config = AceGUI:Create("Frame")
	config:Hide()
	self.config = config
	config:SetTitle("AddonManage 1.1.0a-release")
	function config:CheckDeps(t)
		if not AddonManage.rdeps[t] then return end
		for _, title in ipairs(AddonManage.rdeps[t]) do
			if self.groups[AddonManage.nums[title]] then
				self.groups[AddonManage.nums[title]]:CheckLoadable()
			end
		end
	end
	config:SetLayout("List")
	local sets = AceGUI:Create("Frame")
	sets:Hide()
	config.sets = sets
	sets.sets = {}
	sets:SetTitle("Manage sets")
	sets:SetWidth(200)
	sets:SetHeight(300)
	sets:SetLayout("List")
	local setbuttons = AceGUI:Create("SimpleGroup")
	setbuttons:SetFullWidth(true)
	sets:AddChild(setbuttons)
	setbuttons:SetLayout("Flow")
	local select = AceGUI:Create("Dropdown")
	select:SetCallback("OnValueChanged", function(self, callback, key) AddonManage.CurEditSet = AddonManage_Sets[key] sets:EnableAll() sets:SetValues(AddonManage.CurEditSet.addons) end)
	select:SetFullWidth(true)
	select:SetList(AddonManage:GenerateSetList())
	select:SetDisabled(true)
	sets.select = select
	local add = AceGUI:Create("Icon")
	add:SetWidth(20)
	add:SetHeight(20)
	add:SetImage("Interface\\Buttons\\UI-PlusButton-Up")
	add:SetImageSize(20,20)
	setbuttons:AddChild(add)
	local edit = AceGUI:Create("Icon")
	edit:SetImage("Interface\\AddOns\\AddonManage\\edit")
	edit:SetHeight(20)
	edit:SetWidth(20)
	edit:SetImageSize(20,20)
	setbuttons:AddChild(edit)
	local delete = AceGUI:Create("Icon")
	delete:SetImage("Interface\\Buttons\\UI-MinusButton-UP")
	delete:SetHeight(20)
	delete:SetWidth(20)
	delete:SetImageSize(20,20)
	delete:SetCallback("OnClick", function() if not AddonManage_Sets then return end
		AddonManage_Sets[AddonManage.CurEditSet.name] = nil AddonManage.CurEditSet = nil select:SetList(AddonManage:GenerateSetList()) select:SetText("") sets:DisableAll()
	end)
	setbuttons:AddChild(delete)
	sets:AddChild(select)
	local setscroll = AceGUI:Create("ScrollFrame")
	sets:AddChild(setscroll)
	setscroll:SetFullWidth(true)
	setscroll:SetFullHeight(true)
	setscroll:SetLayout("List")
	setscroll:PauseLayout()
	local setedit = AceGUI:Create("Frame")
	sets.setedit = setedit
	add:SetCallback("OnClick", function() setedit:Show() table.wipe(setedit.data) setedit.namebox:SetText("") setedit.filter:SetText("") setedit.events:SetList(EventList) setedit.apply:SetDisabled(true) end)
	edit:SetCallback("OnClick", function()
		setedit:Show()
		table.wipe(setedit.data)
		setedit.namebox:SetText(AddonManage.CurEditSet.name)
		setedit.filter:SetText(AddonManage.CurEditSet.filter)
		setedit.data.name = AddonManage.CurEditSet.name
		setedit.data.filter = AddonManage.CurEditSet.filter
		setedit.events:SetList(EventList)
		setedit.data.events = {}
		for i in pairs(AddonManage.CurEditSet.events) do
			setedit.events:SetItemValue(i,true)
			setedit.data.events[i] = true
		end
		setedit.apply:SetDisabled(false)
	end)
	setedit.data = {}
	setedit:Hide()
	setedit:SetHeight(300)
	setedit:SetWidth(200)
	setedit:SetPoint("LEFT", sets.frame, "RIGHT")
	setedit:SetTitle("Edit set")
	setedit:SetLayout("List")
	setedit.namebox = AceGUI:Create("EditBox")
	setedit.namebox:SetLabel("Name")
	setedit.namebox:SetCallback("OnEnterPressed", function(w,c,text) setedit.data.name = text if text ~= "" then setedit.apply:SetDisabled(false) else setedit.apply:SetDisabled(true) end ClearEditBoxFocus(w) end)
	setedit.namebox:SetFullWidth(true)
	setedit:AddChild(setedit.namebox)
	setedit.events = AceGUI:Create("Dropdown")
	setedit.events:SetLabel("Events")
	setedit.events:SetList(EventList)
	setedit.events:SetMultiselect(true)
	setedit.events:SetCallback("OnValueChanged", function(self,callback,key,checked) setedit.data.events = setedit.data.events or {} setedit.data.events[key] = checked or nil end)
	setedit.events:SetFullWidth(true)
	setedit:AddChild(setedit.events)
	setedit.filter = AceGUI:Create("MultiLineEditBox")
	setedit.filter:SetLabel("Filter")
	--setedit.filter:SetNumLines(10)
	setedit.filter:SetFullWidth(true)
	setedit.filter:SetCallback("OnEnterPressed", function(w,c,text) setedit.data.filter = text ClearEditBoxFocus(w) end)
	setedit:AddChild(setedit.filter)
	setedit.apply = AceGUI:Create("Button")
	setedit.apply:SetText("Apply changes")
	setedit.apply:SetDisabled(true)
	setedit.apply:SetCallback("OnClick", function()
		local d = setedit.data
		if not AddonManage_Sets[d.name] then
			AddonManage_Sets[d.name] = {name=d.name, events=d.events or {}, filter=d.filter, addons={}}
			setedit.events:SetList(EventList)
			setedit.namebox:SetText("")
			setedit.filter:SetText("")
			setedit.apply:SetDisabled(true)
			select:SetList(AddonManage:GenerateSetList())
			AddonManage:ReRegisterEvents()
			setedit:Hide()
		else
			local popup = StaticPopup_Show("ADDONMANAGE_SETOVERWRITE", d.name)
			popup.data = d
			popup.data2 = setedit
		end
	end)
	setedit.apply:SetFullWidth(true)
	setedit:AddChild(setedit.apply)
	local events = AceGUI:Create("Button")
	events:SetFullWidth(true)
	events:SetText("Manage sets")
	events:SetCallback("OnClick", function() if sets:IsShown() then sets:Hide() else sets:Show() end end)
	config:AddChild(events)
	local scrollframe = AceGUI:Create("ScrollFrame")
	config:AddChild(scrollframe)
	scrollframe:SetFullWidth(true)
	scrollframe:SetFullHeight(true)
	scrollframe:SetLayout("List")
	scrollframe:PauseLayout()
	config.groups = {}
	local a = CreateFrame("Frame")
	a.n = 0
	a.t = 0
	function config:ResumeLayouts()
		if not a.loadfin then return end
		config:SetStatusText("Rendering GUI... This may freeze your screen for a few seconds...")
		scrollframe:ResumeLayout()
		scrollframe:DoLayout()
		setscroll:ResumeLayout()
		setscroll:DoLayout()
		select:SetDisabled(false)
		config:UpdateStatusText()
		AddonManage.IsLayouted = true
	end
	local numaddons = #at
	--for n, data in ipairs(at) do
	local loadfunc = function(self, elapsed)
		if InCombatLockdown() then return end
		self.t = self.t+elapsed
		--if self.t < (config.frame:IsShown() and 0.01 or 1) then return end
		if self.t < 0.01 then return end
		self.t  = 0
		self.n = a.n+1
		local n = self.n
		local data = at[n]
		if data --[[and (n <= 50)--]] then
			local t ="Loading "..(math.floor((n/numaddons)*1000)/10).."% complete."
			if t ~= self.tc then
				config:SetStatusText(t)
				self.tc = t
			end
			local group = AceGUI:Create("SimpleGroup")
			group:SetLayout("Flow")
			group:SetFullWidth(true)
			local name = AceGUI:Create("InteractiveLabel")
			name:SetText(uncolorstring(data.t))
			name:SetColor(1,1,1)
			name:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			name:SetCallback("OnEnter", function(self)
				GameTooltip:SetOwner(self.frame, "ANCHOR_NONE")
				GameTooltip:ClearAllPoints()
				GameTooltip:SetPoint("TOPLEFT", self.frame, "BOTTOMLEFT")
				GameTooltip:ClearLines()
				GameTooltip:AddLine(data.t)
				GameTooltip:AddLine(data.n)
				GameTooltip:Show()
			end)
			name:SetCallback("OnLeave", function() GameTooltip:Hide() end)
			name:SetRelativeWidth(0.49)
			group:AddChild(name)
			local toggle = AceGUI:Create("InteractiveLabel")
			toggle:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			function group:IsLoadable()
				if not data.l then
					return false, _G["ADDON_"..data.r]
				end
				for i,k in ipairs(data.d) do
					--[[if (not k:find("Blizzard_%S+") and ((not AddonManage.nums[k]) or (not AddonManage.titles[k]))) then
						print(k, AddonManage.nums[k], AddonManage.titles[k])
					end--]]
					if k:find("Blizzard_%S+") then
					elseif (not AddonManage.nums[k]) then
						return false, ADDON_DEP_MISSING
					elseif (AddonManage.addons[AddonManage.nums[k]].e and (not AddonManage.update[AddonManage.titles[k]])) then
					elseif ((not AddonManage.addons[AddonManage.nums[k]].e) and AddonManage.update[AddonManage.titles[k]]) then
					else
						--print(data.t.." can not be loaded ("..k.." disabled)")
						return false, ADDON_DEP_DISABLED
					end
				end
				return true
			end
			function group:CheckLoadable()
				if AddonManage.update[data.t] then
					if data.e then
						toggle:SetText("DISABLE")
						toggle:SetColor(1,0,0)
					else
						toggle:SetText("ENABLE")
						toggle:SetColor(0,1,0)
					end
				else
					if data.e then
						toggle:SetText("ENABLED")
						toggle:SetColor(0,0.5,0)
					else
						toggle:SetText("DISABLED")
						toggle:SetColor(0.5,0,0)
					end
				end
				local isLoadable, loadError = self:IsLoadable()
				if isLoadable then
					toggle:SetCallback("OnClick", function()
						AddonManage.update[data.t] = not AddonManage.update[data.t]
						config:CheckDeps(data.f)
						group:CheckLoadable()
						config:UpdateStatusText()
					end)
					toggle:SetCallback("OnEnter", nil)
					toggle:SetCallback("OnLeave", nil)
				else
					toggle:SetCallback("OnClick", nil)
					toggle:SetCallback("OnEnter", function(self)
						GameTooltip:SetOwner(self.frame, "ANCHOR_NONE")
						GameTooltip:ClearAllPoints()
						GameTooltip:SetPoint("TOPLEFT", self.frame, "BOTTOMLEFT")
						GameTooltip:ClearLines()
						GameTooltip:AddLine("Unloadable")
						GameTooltip:AddLine(loadError)
						GameTooltip:Show()
					end)
					toggle:SetCallback("OnLeave", function() GameTooltip:Hide() end)
					toggle:SetColor(0.2,0.2,0.2)
				end
			end
			name:SetCallback("OnClick", function()
				toggle.frame:GetScript("OnMouseDown")(toggle.frame, "LeftButton")
			end)
			toggle:SetRelativeWidth(0.49)
			group:AddChild(toggle)
			local filler = AceGUI:Create("Label")
			filler:SetHeight(20)
			filler:SetFullWidth(true)
			filler:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			filler:SetText("")
			group:AddChild(filler)
			scrollframe:AddChild(group)
			config.groups[n] = group
			local setsgroup = AceGUI:Create("SimpleGroup")
			setsgroup:SetLayout("Flow")
			setsgroup:SetFullWidth(true)
			local setsname = AceGUI:Create("InteractiveLabel")
			setsname:SetText(uncolorstring(data.t))
			setsname:SetColor(1,1,1)
			setsname:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			setsname:SetCallback("OnEnter", function(self)
				GameTooltip:SetOwner(self.frame, "ANCHOR_NONE")
				GameTooltip:ClearAllPoints()
				GameTooltip:SetPoint("TOPLEFT", self.frame, "BOTTOMLEFT")
				GameTooltip:ClearLines()
				GameTooltip:AddLine(data.t)
				GameTooltip:AddLine(data.n)
				GameTooltip:Show()
			end)
			setsname:SetCallback("OnLeave", function() GameTooltip:Hide() end)
			setsname:SetRelativeWidth(0.8)
			setsgroup:AddChild(setsname)
			local setstoggle = AceGUI:Create("CheckBox")
			setstoggle:SetTriState(true)
			setsname:SetCallback("OnClick", function()
				setstoggle.frame:GetScript("OnMouseDown")(setstoggle.frame, "LeftButton")
			end)
			setstoggle:SetRelativeWidth(0.19)
			setstoggle:SetDisabled(true)
			setstoggle:SetCallback("OnValueChanged", function(widget, callback, value)
				AddonManage.CurEditSet.addons[data.f] = value or (value == false and nil or false)
			end)
			setsgroup:AddChild(setstoggle)
			setsgroup.t = setstoggle
			local setsfiller = AceGUI:Create("Label")
			setsfiller:SetHeight(20)
			setsfiller:SetFullWidth(true)
			setsfiller:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			setsfiller:SetText("")
			setsgroup:AddChild(setsfiller)
			setscroll:AddChild(setsgroup)
			tinsert(sets.sets,setsgroup)
			sets.sets[data.f] = setsgroup
		else
			for num, g in ipairs(config.groups) do
				g:CheckLoadable()
			end
			local applygroup = AceGUI:Create("InlineGroup")
			applygroup:SetFullWidth(true)
			applygroup:SetLayout("Flow")
			local applyfiller = AceGUI:Create("Label")
			applyfiller:SetFont("FONTS\\FRIZQT__.TTF", 12, "OUTLINE")
			applyfiller:SetRelativeWidth(0.7)
			applyfiller:SetText("")
			applygroup:AddChild(applyfiller)
			local apply = AceGUI:Create("Button")
			apply:SetText("Apply changes")
			apply:SetRelativeWidth(0.3)
			apply:SetCallback("OnClick", function() for i,k in ipairs(AddonManage.addons) do if AddonManage.update[k.t] then if k.e then DisableAddOn(k.i) else EnableAddOn(k.i) end end end ReloadUI() end)
			apply:SetHeight(30)
			applygroup:AddChild(apply)
			config:AddChild(applygroup)
			function config:UpdateStatusText()
				local enable, disable = 0,0
				for n,k in ipairs(AddonManage.addons) do
					if AddonManage.update[k.t] then
						if k.e then
							disable = disable+1
						else
							enable = enable+1
						end
					end
				end
				self:SetStatusText((enable+disable).." pending changes ("..enable.." enables, "..disable.." disables)")
				if (enable+disable) > 0 then
					applygroup.frame:Show()
					apply:SetDisabled(false)
				else
					applygroup.frame:Hide()
					apply:SetDisabled(true)
				end
			end
			self:SetScript("OnUpdate", nil)
			if config:IsShown() or config.sets:IsShown() then
				config:SetStatusText("Rendering GUI... This may freeze your screen for a few seconds...")
				scrollframe:ResumeLayout()
				scrollframe:DoLayout()
				setscroll:ResumeLayout()
				setscroll:DoLayout()
				select:SetDisabled(false)
				AddonManage.IsLayouted = true
			end
			config:UpdateStatusText()
			self.loadfin = true
		end
	end
	function sets:EnableAll()
		for index, group in ipairs(self.sets) do
			group.t:SetDisabled(false)
		end
	end
	function sets:DisableAll()
		for index, group in ipairs(self.sets) do
			group.t:SetDisabled(true)
		end
	end
	function sets:SetValues(values)
		for index, group in ipairs(self.sets) do
			group.t:SetValue(false)
		end
		for folder, status in pairs(values) do
			if status == false then status = nil end
			if self.sets[folder] then
				self.sets[folder].t:SetValue(status)
			end
		end
	end
	a:SetScript("OnUpdate", loadfunc)
	self.loadfunc = loadfunc
	self.updateframe = a
	config:SetCallback("OnClose", function(self) self:Hide() end)
		--if n > 50 then break end
	--end
	SlashCmdList["ADDONMANAGE"] = function() AddonManage.config:Show() if not AddonManage.IsLayouted then AddonManage.config:ResumeLayouts() end end
	SLASH_ADDONMANAGE1 = "/addons"
	SLASH_ADDONMANAGE2 = "/addon"
	SLASH_ADDONMANAGE3 = "/addonmanage"
	AddonManage:ReRegisterEvents()
end